﻿using System;
using System.Text;

namespace HealthyHitsujiWpf.Model.DataBase
{
    public class MonthDataBaseFile : _IDataBaseModel
    {

        #region ▼フィールド

        public static readonly String HitsujiDirectory_ = "HITSUJIs";
        public static readonly String AppDirectory_ = "HealthyHitsuji";
        public static readonly String MonthDataDirectory_ = "MONTH_DATA";
        public static readonly String CsvFileName_AsCalorieDataOutPut = "CALORIE";
        public static readonly String CsvFileName_AsBalanceDataOutPut = "BALANCE";
        public static readonly String CsvFileName_AsPrimaryDataOutPut = "PRIMARY";
        public static readonly String CsvFileName_AsAllDataOutPut = "MONTH";

        #endregion ▲フィールド


        #region ▼各パス生成メソッド

        /// <summary>
        /// 月データ格納フォルダのパスを生成
        /// </summary>
        /// <returns></returns>
        public static StringBuilder getDirectoryPath_AsMonthData()
        {
            //return new StringBuilder(System.Environment.GetFolderPath(System.Environment.SpecialFolder.ProgramFiles))
            return new StringBuilder(System.Environment.GetFolderPath(System.Environment.SpecialFolder.Personal))
                            .Append("\\").Append(HitsujiDirectory_)
                            .Append("\\").Append(AppDirectory_)
                            .Append("\\").Append(MonthDataDirectory_)
                            .Append("\\");
        }
        

        /// <summary>
        /// 『月データ格納フォルダ\yyyyMM.xml』のパスを生成
        /// 主な用途：月データファイルの読込み/作成
        /// </summary>
        /// <param name="year"></param>
        /// <param name="month"></param>
        /// <returns></returns>
        public static StringBuilder buildDataBaseFilePath(int year, int month)
        {
            return new StringBuilder(getDirectoryPath_AsMonthData().ToString())
                             .Append(year.ToString("0000"))
                             .Append(month.ToString("00"))
                             .Append(".xml");
        }


        /// <summary>
        /// 『月データ格納フォルダ\TEMP.xml』のパスを生成
        /// 主な用途：月データファイル更新時に、一時退避ファイルとして作成
        /// </summary>
        /// <returns></returns>
        public static StringBuilder buildTempDataBaseFile()
        {
            return new StringBuilder(getDirectoryPath_AsMonthData().ToString())
                            .Append("TEMP")
                            .Append(".xml");

        }

        #endregion ▲各パス生成メソッド

    }
}
