﻿using System;
using System.ComponentModel;
using HealthyHitsujiWpf.Model.Content;

namespace HealthyHitsujiWpf.Model.View
{
    public class MonthDataListBoxViewModel : _AViewModel, INotifyPropertyChanged
    {

        #region ▼コンストラクタ

        public MonthDataListBoxViewModel()
        {
            this.SelectedDateContentsInfo_ = UiModelFactry.createDateContentsModelAsMonthDataMember();
            
        }

        #endregion ▲コンストラクタ


        #region ▼プロパティ

        //選択日付をあらわすデータモデル
        private DateContentsModel SelectedDateContentsInfo_;
        public DateContentsModel SelectedDateContentsInfo
        {
            get { return SelectedDateContentsInfo_; }
            set
            {
                if (value != null)
                {
                    SelectedDateContentsInfo_ = value;

                    //クリック時の詳細処理を登録
                    if (this.SelectedDateContentsInfo.canExeDelegate_ == null)
                        this.SelectedDateContentsInfo.canExeDelegate_ = this.canSelectionItemChangedEvent;
                    if (this.SelectedDateContentsInfo.exeDelegate_ == null)
                        this.SelectedDateContentsInfo.exeDelegate_ = this.executeSelectionItemChangedEvent;
                    //イベントを発生させるため、プロパティ更新
                    SelectedDateContentsInfo.SelectedDateLabel = value.SelectedDateLabel;
                }
            }
        }

        //リストアイテム
        private MonthContentsModel listBoxItemsSource_;
        public MonthContentsModel listBoxItemsSource
        {
            get { return listBoxItemsSource_; }
            set
            {
                listBoxItemsSource_ = value;
                OnListBoxItemsSourceChanged("listBoxItemsSource");
            }
        }
        #endregion ▲プロパティ


        #region ▼INotifyPropertyChanged メンバ

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnListBoxItemsSourceChanged(String propertyName)
        {
            try
            {
                PropertyChangedEventHandler handle = PropertyChanged;
                if (handle != null)
                    handle(this, new PropertyChangedEventArgs(propertyName));
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

        #endregion ▲INotifyPropertyChanged メンバ


        #region ▼アイテムクリック時の処理関連

        public bool canSelectionItemChangedEvent()
        {
            return true;
        }

        //アイテム選択時の処理（カレンダーの選択日付更新）
        public void executeSelectionItemChangedEvent()
        {
            try
            {
                var calendarVM = (CalendarViewModel)this.parentVM_.getViewModelMember("CalendarViewModel");
                calendarVM.SelectedDateData.SelectedDate = new DateTime(this.SelectedDateContentsInfo.Year,
                                                                        this.SelectedDateContentsInfo.Month,
                                                                        this.SelectedDateContentsInfo.Day);
           
            }
            catch (Exception ex)
            {
                Console.Write(ex.ToString());
            }
        }

        #endregion ▲アイテムクリック時の処理関連

    }
}
